/****************************************************************************

 * Copyright (c) 2008-2009, Intel Corporation.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.

File Name:          PMGlobalConstant.h

Description:

    This file defines global constant.

Environment (opt):

    OS: Ubuntu
    SE: Code::Block

Notes (opt):

  =====================================================================

  Revision   Revision History               Author     Date

  =====================================================================

  0.1        Create                         Deng Jing 2008-7-20

  =====================================================================

****************************************************************************/

#ifndef PMGLOBALCONSTANT_H_INCLUDED
#define PMGLOBALCONSTANT_H_INCLUDED

#include <string>
using namespace std;

const wxString PIC_PATH = wxT("/etc/ipower-management/pictures/");
const wxString TITLE_ICON = PIC_PATH + wxT("Battery.png");
const wxString RESOURCE_DIR = wxT("/etc/ipower-management/resource/");
//const int DEVICE_LIST_NUM = 2;
//const wxString DEVICE_LIST[DEVICE_LIST_NUM][DEVICE_LIST_NUM] = {{wxT("LAN"), _("LAN")}, {wxT("Wireless"), _("Wireless")}};

const wxString GLOBAL_CONFIG_DIR = wxT("/etc/ipower-management/config-file-bak/");
const wxString HELP_DIR = wxT("/usr/share/doc/power-management/");

const wxString SCHEME_FILENAME = wxT("/PowerScheme_pmsch.xml");
const wxString OPTION_FILENAME = wxT("/Options.xml");
const wxString COMMON_FILENAME = wxT("/CommonSettings.xml");
const wxString HELP_FILENAME = wxT("/Intel_CMPC2.0_PowerManagement_UserManual.pdf.gz");
const wxString LANG_FILENAME = wxT("/.lang");
const wxString LANG_DEFAULT_EN = wxT("EN");

const wxString PRIVATE_DIR = wxT("/.ipm");
const string PRIVATE_SCHEME_FILEPATH("/.ipm/PowerScheme_pmsch.xml");

const unsigned int INVALID_VALUE = -1;
const unsigned int BAT_FULL_CAP = 100;
const unsigned int BAT_NULL_CAP = 0;
const unsigned int BAT_OVER_TIME = 600;
const unsigned int HIGHPOINT = 60;
const unsigned int MIDPOINT = 30;

#endif // PMGLOBALCONSTANT_H_INCLUDED
